/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// Arbres binaires de recherche

// réalisant ici un tableau associatif (dictionnaire) des chaînes (char*)
// vers les entiers (int)

#include "prelude.h"

#ifndef BST
#define BST

typedef struct Bst bst;

bst *bst_create(void);
bool bst_is_empty(bst *t);
void bst_put(bst *t, char *k, int v);
bool bst_contains(bst *t, char *k);
int bst_get(bst *t, char *k);
  // renvoie -1 si la clé n'est pas dans le dictionnaire
char *bst_min_elt(bst *t);
  // renvoie NULL si t est vide
void bst_print(bst *t);
void bst_delete(bst *t);

#endif
